#ifndef __MODEL__
#define __MODEL__

#import "../sgCore/sgCore.h"

#include <vector>

class   StaircaseModel
{
public:
	StaircaseModel() {};

	void   Build(sgFloat in_rad, sgFloat out_rad, sgFloat stairH, unsigned int helix_cnt, unsigned int steps_cnt);

private:
	sgFloat m_in_radius;
	sgFloat m_out_radius;
	sgFloat m_stair_height;
	unsigned int m_helix_count;
	unsigned int m_steps_count;

	sgCContour*   BuildStepContour();
	sgC3DObject*  BuildOneStep(const sgCContour* stepCont);

	sgCContour*   BuildGuideContour(bool insideGuide);
	sgC3DObject*  BuildOneGuide(const sgCContour* guideCont,bool insideGuide);

	sgCContour*   BuildBalusterContour();
	sgC3DObject*  BuildBaluster(const sgCContour* balusterCont);

	sgCContour*   BuildHandrailContour();
	sgC3DObject*  BuildHandrail(const sgCContour* HandrailCont);
};

void BuildModel();

#endif