// Demo.cpp
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Demo.h"
#include <stdio.h>

#include "OpenGL//Painter.h"

#include "Model//Model.h"

/////////////////////////////////////////////////////////////////////////////
// Global CDemoApp object

CDemoApp gApp;


/////////////////////////////////////////////////////////////////////////////
// CDemoApp construction/destruction

CDemoApp::CDemoApp()
{
}

CDemoApp::~CDemoApp()
{
}

//
// PreCreateWindow()
// Called before the main window is created. Override this function to change window creation params.
//
void CDemoApp::PreCreateWindow(WNDCLASSEX &wcex, DWORD &dwStyle, DWORD &dwExStyle, int &x, int &y, int &cx, int &cy)
{
  CApp::PreCreateWindow(wcex, dwStyle, dwExStyle, x, y, cx, cy);
  // TODO : Modify parameters to change default window style and/or size
}


//
// OnCommand()
// Override this function to handle WM_COMMAND messages sent to the main window.
//
BOOL CDemoApp::OnCommand(int nCmdID, int nEvent)
{
 return CApp::OnCommand(nCmdID, nEvent); // Call default handler
 
}

//
// WindowProc()
// Override this function to handle messages sent to the main window.
//
LRESULT CDemoApp::WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  return CApp::WindowProc(hWnd, message, wParam, lParam); // Call default WindowProc
}

//
// InitScene()
// Called when the OpenGL RC has been created. Sets initial state for the OpenGL scene.
//
void CDemoApp::InitScene()
{

  BuildModel();
 

  // Lights properties
  //float ambientProperties[]  = {0.1f, 0.1f, 0.1f, 1.0f};
  float diffuseProperties[]  = {1.0f, 1.0f, 1.0f, 1.0f};
  float specularProperties[] = {1.0f, 1.0f, 1.0f, 1.0f};

  //glLightfv( GL_LIGHT0, GL_AMBIENT, ambientProperties);
  glLightfv( GL_LIGHT0, GL_DIFFUSE,diffuseProperties);
  glLightfv( GL_LIGHT0, GL_SPECULAR, specularProperties);
  glLightModelf(GL_LIGHT_MODEL_TWO_SIDE, 1.0);

  glClearColor(1.0,1.0,1.0,1.0f);

  glHint(GL_LINE_SMOOTH_HINT,GL_FASTEST);

  // Texture
  glEnable(GL_TEXTURE_2D);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);


  // Default : lighting

  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);


  // Default : blending
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

  glEnable(GL_DEPTH_TEST);

  //  glEnable(GL_CULL_FACE);
}

//
// KillScene()
// Called when the OpenGL RC is about to be destroyed.
//
void CDemoApp::KillScene()
{
  // TODO: Use KillScene to free resources.
}

//
// DrawScene()
// Called each time the OpenGL scene has to be drawn.
//
void CDemoApp::DrawScene()
{
// TODO: Replace the following sample code with your code to draw the scene.

  sgCObject*  curObj = sgGetScene()->GetObjectsList()->GetHead();
  while (curObj)
  {
    if (true)
    {
      Painter::DrawObject(GL_RENDER,curObj,false);

      if ((curObj->GetAttribute(SG_OA_DRAW_STATE) & SG_DS_GABARITE))
      {
        SG_POINT a1,a2;
        curObj->GetGabarits(a1,a2);
        Painter::DrawGabariteBox(a1,a2);
      }
    }
    curObj = sgGetScene()->GetObjectsList()->GetNext(curObj);
  }
}
